#Basic Information
%define driver_name qla4xxx
%define driver_version_rhel5   5.02.15.06.05.07-k0
%define driver_version_sles10  5.02.15.06.10.4-d0
%define driver_version_rhel6   5.02.15.06.05.06-c0
%define driver_version_sles11 %{driver_version_rhel6}
%define driver_version_sles11sp2 5.02.15.06.03.00-k0

%define early_rules		05-udev-early.rules

%define release	4

%if %{!?SRCVER:0}%{?SRCVER:1}
%define hostversion %(echo %{SRCVER})
%else
%if "%{_vendor}" == "redhat"
%define rhel_version %(cat /etc/redhat-release | cut -d " " -f 7 | cut -d "." -f 1)
%if "%{rhel_version}" == "6"
%define hostversion %{driver_version_rhel6}
%else "%{rhel_version}" == "5"
%define hostversion %{driver_version_rhel5}
%endif
%endif

%if "%{_host_vendor}" == "suse"
%define sles_version %(cat /etc/SuSE-release | grep "SUSE Linux Enterprise" | cut -d " " -f 5)
%define sp_ver %(cat /etc/issue | cut -d " " -f 8 | grep SP)
%if "%{sles_version}" == "11"
%if %{sp_ver} == SP1 
%define hostversion %{driver_version_sles11}
%else
%define hostversion %{driver_version_sles11sp2}
%endif
%else
%define hostversion %{driver_version_sles10}
%endif
%endif

%define dversion %( (echo "%{hostversion}" | cut -d '-' -f1) )
%define driver_version_sles101 %( (echo "%{driver_version_sles10}" | cut -d 'v' -f2) )
%define kmod_vendor hp
%define kmod_name qla4xxx
%define kmod_full_name %{kmod_vendor}-%{kmod_name}

Name: %{kmod_full_name}
Version: 5.02.15.06
Release: %{release}
Group: System Environment/Kernel
Vendor: QLogic corporation
Packager: Hewlett-Packard Company
License: GPL
Source0: %{driver_name}-%{driver_version_rhel5}.tar.gz
Source2: %{driver_name}-%{driver_version_sles101}.tar.gz
Source3: %{driver_name}-%{driver_version_rhel6}.tar.gz
Source4: %{driver_name}-%{driver_version_sles11sp2}.tar.gz
Source5: 99-qla4xxx.rules
Source6: qla4xxx_udev.sh
Source7: %{early_rules} 

URL: http://www.qlogic.com
Buildroot: %{_tmppath}/%{name}-%{version}-k/bldroot
Summary: QLogic driver for QMH4062 iSCSI HBA.

%define packinfo "This package contains Qlogic driver for QMH4062 iSCSI HBA"
%define debug_package %{nil}

%if %{!?KVER:0}%{?KVER:1}
%define custom 1
%else
%define custom 0
%endif

%if "%{_host_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%if %{sp_ver} == "SP1" 
%ifarch x86_64
%define flav debug default kdump smp xen trace
%else
%define flav bigsmp debug default kdump kdumppae smp vmi vmipae xen xenpae pae trace
%endif
%else
%ifarch x86_64

%define flav debug default kdump smp xen trace
%else

%define flav bigsmp debug default kdump kdumppae smp vmi vmipae xen xenpae pae trace
%endif
%endif
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%define kverrel %(echo %{KVER} | awk -F"-" '{print $1"-"$2}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%{!?kernel_version: %global kernel_version %( if [ -z "${KERNEL}" ]; then ( echo "`uname -r`"); else ( echo "${KERNEL}"); fi )}
%define rhel_version %(cat /etc/redhat-release | grep "Red Hat Enterprise" | cut -d " " -f 7)
%if %{!?KVER:1}%{?KVER:0}
%define kverrel %(echo "`uname -r`")
%define flav %(echo %{qlkverrel} | awk -F"el5" '{print $2}')
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')

%if "%{rhel_version}" == "6.0"
%define kverrel %(echo %{KVER} | awk -F"el6 '{print $1"el6"$2}')
%else
%define kverrel %(echo %{KVER} | awk -F"el5" '{print $1"el5"$2}')
%endif
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%description
%{packinfo}

%if "%{_host_vendor}" == "suse"
BuildRequires: kernel-source kernel-syms
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}
%else
BuildRequires: %kernel_module_package_buildreqs
%{kernel_module_package %flav}
%endif

%prep
cp %{S:5} .
cp %{S:6} .
cp %{S:7} .

%if "%{_vendor}" == "redhat"
%define rhel_version %(cat /etc/redhat-release | cut -d " " -f 7 | cut -d "." -f 1)
%if "%{rhel_version}" == "6"
%setup -T -b 3 -n  %{driver_name}-%{driver_version_rhel6}
%else "%{rhel_version}" == "5"
%setup -T -b 0 -n  %{driver_name}-%{driver_version_rhel5}
%endif
%endif

%if "%{_host_vendor}" == "suse"
%define sles_version %(cat /etc/SuSE-release | grep "SUSE Linux Enterprise" | cut -d " " -f 5)
%define sp_ver %(cat /etc/issue | cut -d " " -f 8 | grep SP)
%if "%{sles_version}" == "11"
%if %{sp_ver} == "SP1" 
%setup -T -b 3 -n  %{driver_name}-%{driver_version_sles11}
%else
%setup -T -b 4 -n  %{driver_name}-%{driver_version_sles11sp2}
%endif
%else
%setup -T -b 2 -n  %{driver_name}-%{driver_version_sles101}
%endif
%endif

set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
#mkdir -p $RPM_BUILD_ROOT/etc/udev/rules.d
#mkdir -p $RPM_BUILD_ROOT/lib/udev
#install -m 755 %{S:5} $RPM_BUILD_ROOT/etc/udev/rules.d
#install -m 755 %{S:6} $RPM_BUILD_ROOT/lib/udev

export EXTRA_CFLAGS='-DVERSION=\"%version\"'
for flavor in %flavors_to_build; do
rm -rf obj/$flavor
cp -r source obj/$flavor
%if "%{rhel_version}" == "6"
cd $PWD/obj/$flavor
make add_version &> /dev/null
cd ../..
%endif
%if "%{sp_ver}" == "SP1"
cd $PWD/obj/$flavor
make add_version &> /dev/null
cd ../..
%endif
make -C %{kernel_source $flavor} modules M=$PWD/obj/$flavor
done

%install
mkdir -p /etc/udev/rules.d
mkdir -p /lib/udev
install -m 755 %{S:5} /etc/udev/rules.d
install -m 755 %{S:6} /lib/udev

export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
%if "%{_host_vendor}" == "suse"
export INSTALL_MOD_DIR=updates/%{name}
%else
export INSTALL_MOD_DIR=extra/%{name}
%endif
for flavor in %flavors_to_build; do
%define INSTALL_MOD_DIR %(echo %{INSTALL_MOD_DIR})
make  -C %{kernel_source $flavor} modules_install M=$PWD/obj/$flavor
#make  -C %{kernel_source $flavor} modules_install M=$INSTALL_MOD_DIR
done

%post
# Udev control adm
if [ -e /etc/udev/rules.d/%{early_rules} ]; then
	cp /etc/udev/rules.d/%{early_rules} /etc/udev/rules.d/%{early_rules}.bak
	cat /etc/udev/rules.d/%{early_rules} | sed "s/\(^SUBSYSTEM==\"module\".*OPTIONS=\"ignore_device\".*\)/#\1/" > /tmp/tmp.rules
	if [ -s /tmp/tmp.rules ]; then
		mv -f /tmp/tmp.rules /etc/udev/rules.d/%{early_rules}
	fi
fi

if [ -f "`which udevcontrol 2>/dev/null`" ]; then
        UDEVCNT="udevcontrol reload_rules"
elif [ -f "`which udevadm 2>/dev/null`" ]; then
        UDEVCNT="udevadm control --reload-rules"
fi

if [ "$UDEVCNT" != "" ]; then
	$UDEVCNT 
fi

#%files
#%defattr(-,root,root)
#%attr(755,root,root) /etc/udev/rules.d/99-qla4xxx.rules
#%attr(755,root,root) /lib/udev/qla4xxx_udev.sh

%clean
rm -rf %{buildroot}

%define major_change (Severity:Critical)
%define medium_change (Severity:Medium)
%define minor_change (Severity:Minor)

%changelog 
*Fri Feb 10 2012 Sarang Radke <sarang.radke@qlogic.com> %{version}-%{release}
- Added udev support
*Thu Dec 28 2011 Sarang Radke <sarang.radke@qlogic.com> %{version}-%{release}
- Add support for SLES11 SP2
*Tue Dec 15 2011 Sarang Radke <sarang.radke@qlogic.com> %{version}-%{release}
- Include new drivers
*Mon Apr 12 2010 Jigar Shah <jigar.shah@qlogic.com> %{version}-%{release}
-modified spec files to fit to accomodate qla4xxx R5/S10/S11 drivers %{major_change}
*Wed Nov 12 2008 Mahesh M.R <Mahesh.Mr@hp.com> %{version}-%{release}
-modified spec files to fit to kernel modules specification %{major_change}

